package generated.javacard.copycardMoneySecure.copycard;

import javacard.framework.Util;

public class Secret implements Codeable, HashData {
	public byte[] secret;

	/**
	 * Konstruktor, setzt alle Klassenattribute auf einen Startwert
	 */
	public Secret() {
		secret = new byte[Store.LENGTHOFSECRET];
	}

	/**
	 * Generierter Konstruktor mit allen Klassenattributen als Parametern
	 */
	public Secret(byte[] secret) {
		this.secret = secret;
	}

	/**
	 * Methode zum Holen des Typflags
	 *
	 * @return den Klassenspezifischen Code
	 */
	public byte getCode() {
		return Code.SECRET;
	}

	/**
	 * Methode zum Pr?fen von Gleichheit kodierbarer Klassen. Diese Methode pr?ft die Werte aller Attribute auf Gleicheit.
	 *
	 * @param other Klasse, mit der verglichen werden soll
	 * @return true, wenn die Werte der Attribute beider Klassen gleich sind
	 */
	public boolean equals(Codeable other) {
		if (getCode() != other.getCode())
			return false;
		return Arrays.equals(secret, ((Secret) other).secret);
	}

	public void copy(Secret from) {
		//Der Typ von secret ist ein Array aus primitiven Typen.
		Arrays.copy(from.secret, this.secret);
	}
}
