package generated.javacard.copycardMoneySecure.copycard;

/**
 * Generated Class
 * 
 */
public class Load extends Message implements Codeable {

	public short amount;
	public HashedData authterminal;

	/**
	 * Constructor wich sets all attributes to a initial value
	 */
	public Load() {
		amount = 0;
		authterminal = new HashedData();
	}

	/**
	 * Method for getting the typeflag
	 *
	 * @return den class-specific code
	 */
	public byte getCode() {
		return Code.LOAD;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */
	public boolean equals(Codeable other) {
		//The types of the objects have to match
		if (getCode() != other.getCode())
			return false;
		//amount is of primitive type: We can use ==
		if (this.amount != ((Load) other).amount)
			return false;
		//Attributes of complex type: Use their equals-method
		if (!this.authterminal.equals(((Load) other).authterminal))
			return false;
		return true;
	}

	public void copy(Load from) {
		//amount is of primitive type: simple assignment
		this.amount = from.amount;
		//Complex types: Use their copy-method.
		this.authterminal.copy(from.authterminal);
	}

}
